﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net.Mail;
using System.Net;
using System.Net.Mime;
using System.DirectoryServices;
using System.Collections;
using System.Threading;
using $safeprojectname$;
using System.Security.AccessControl;
using System.Security.Principal;
using System.DirectoryServices.AccountManagement;


namespace CreateUsersFromCsv
{

    public partial class Form1 : Form
    {


        public Form1()
        {
            InitializeComponent();


        }


        void Clear_all()
        {

            dataGridView1.Columns.Clear();

            if (importFileButton.Equals(true))
            {
                openFileDialog1.ShowDialog();
                ReadCSV(openFileDialog1.FileName);
            }

        }

        void ReadCSV(String file)
        {
            Clear_all();
            String rowValue;
            string[] cellValue;

            if (System.IO.File.Exists(file))
            {
                StreamReader streamReader = new StreamReader(file);
                rowValue = streamReader.ReadLine();
                cellValue = rowValue.Split(';');

                for (int i = 0; i <= cellValue.Count() - 1; i++)
                {
                    DataGridViewTextBoxColumn column = new DataGridViewTextBoxColumn();

                    column.Name = cellValue[i];
                    column.HeaderText = cellValue[i];
                    dataGridView1.Columns.Add(column);



                }

                while (streamReader.Peek() != -1)
                {
                    rowValue = streamReader.ReadLine();
                    cellValue = rowValue.Split(';');
                    dataGridView1.Rows.Add(cellValue);

                }


                streamReader.Close();



            }

        }


        void SaveCSV(String file)
        {
            StreamWriter streamWriter = new StreamWriter(file);
            string strHeader = "";


            for (int i = 0; i < dataGridView1.Columns.Count; i++)
            {
                strHeader += dataGridView1.Columns[i].HeaderText + ";";
            }

            strHeader = strHeader.TrimEnd(';');

            streamWriter.WriteLine(strHeader);

            for (int m = 0; m < dataGridView1.Rows.Count - 1; m++)
            {
                string strRowValue = "";

                for (int n = 0; n < dataGridView1.Columns.Count; n++)
                {
                    strRowValue += dataGridView1.Rows[m].Cells[n].Value + ";";
                }
                strRowValue = strRowValue.TrimEnd(';');
                streamWriter.WriteLine(strRowValue);
            }


            streamWriter.Close();
        }



        private void importFileButton_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            ReadCSV(openFileDialog1.FileName);





        }

        private void buttonSaveChanges_Click(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
            SaveCSV(saveFileDialog1.FileName);
        }


        private static List<string[]> ReadAndParsedData(string path, char sepearator)
        {
            var parsedData = new List<String[]>();
            using (var sr = new StreamReader(path))
            {
                string line;
                while ((line = sr.ReadLine()) != null)
                {
                    string[] row = line.Split(sepearator);
                    parsedData.Add(row);
                }

            }
            return parsedData;
        }


        private void DrawDataGridView(List<string[]> parsedData)
        {
            dataGridView1.Rows.Clear();
            dataGridView1.ColumnCount = 10;
            for (int i = 0; i < 10; i++)
            {
                var sb = new StringBuilder(parsedData[0][i]);
                sb.Replace('_', ' ');
                sb.Replace("\"", "");
                dataGridView1.Columns[i].Name = sb.ToString();
            }

            foreach (string[] row in parsedData)
            {
                dataGridView1.Rows.Add(row);
            }
            dataGridView1.Rows.Remove(dataGridView1.Rows[0]);
        }


        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }



        private void Form1_Load(object sender, EventArgs e)
        {

        }



        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        private void dataGridView1_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void buttonOriginalValues_Click_1(object sender, EventArgs e)
        {
            List<String[]> parsedData = ReadAndParsedData(@"Z:/UserCreator/Datafiles/Cleared.csv", ';');

            DrawDataGridView(parsedData);
            checkGeneratedUsersLabel.Text = "";

        }





        private void sendToITButton_Click(object sender, EventArgs e)
        {

            string userName = "No-reply@mail.dk";
            string passwd = "";
            string myuser = System.Security.Principal.WindowsIdentity.GetCurrent().Name;

            string thisUser = Environment.UserName;
            string thisComputer = System.Environment.MachineName;
            string userProfile = Environment.GetFolderPath(Environment.SpecialFolder.UserProfile);
            string strFile = userProfile + @"\Desktop\HoldOprettelse_" + thisUser + "_" + thisComputer + ".csv";



            SendCurrentCsv(strFile); // Sending current CSV in DataGridView to IT@mail.dk


            try
            {





                SmtpClient SMTPServer = new SmtpClient("192.168.90.58");
                SMTPServer.Credentials = new System.Net.NetworkCredential(userName, passwd);

                SmtpClient client = new SmtpClient("192.168.90.58");
                // Port 587 is the preferred port for mail submission. Port 25 is widely abused by malware to spread worms and spam.
                //  As a result, many ISPs are restricting its use. I tried to use it but it didn't work!
                client.Port = 587;
                client.Credentials = new System.Net.NetworkCredential(userName, passwd);
                // Port 587 allows you to use a SSL Connection.
                client.EnableSsl = true;


                Thread T1 = new Thread(delegate()
                {
                    MailMessage mail = new MailMessage(
                "no-reply@mail.dk", "IT@mail.dk", "Brugeroprettelse fra: " + myuser + " " + DateTime.Now, "Hej IT,\r\r\nVenligst opret dem her.\r\r\nSe Vedhæftet fil\r\r\nMed venlig hilsen\r\r\n" + "Username: " + myuser + "\n" + "Computername: " + thisComputer);
                    mail.Attachments.Add(new Attachment(strFile)); // need to change this
                    {
                        {
                            SMTPServer.Send(mail);
                        }
                    }
                });

                T1.Start();

                labelSendingMail.Text = "Mail sent to IT!";


            }
            catch (Exception ex)
            {
                ex.ToString();
                MessageBox.Show("Please tak a screenshot of this, and send to IT@mail.dk", "ERROR has occoured", MessageBoxButtons.OK);
            }




        }

        private void SendCurrentCsv(string strFile)
        {

            StreamWriter sw = new StreamWriter(strFile, false, System.Text.Encoding.UTF8);
            // now add the gridview header in csv file suffix with "," delimeter except last one
            for (int i = 0; i < dataGridView1.Columns.Count; i++)
            {
                sw.Write(dataGridView1.Columns[i].HeaderText);
                if (i != dataGridView1.Columns.Count - 1)
                {
                    sw.Write(";");

                }
            }
            // add new line
            sw.Write(sw.NewLine);

            foreach (DataGridViewRow dr in dataGridView1.Rows)
            {

                for (int i = 0; i < dataGridView1.Columns.Count; i++)
                {
                    // write particular cell to csv file
                    sw.Write(dr.Cells[i].Value);
                    if (i != dataGridView1.Columns.Count - 1)
                    {

                        if (dr.Cells[i].Value != null && dr.Cells[i].Value.ToString().Length > 0)
                            sw.Write(";");

                        // Remove all blank lines!
                        string strRowValue = "";

                        for (int n = 0; n < dataGridView1.Rows.Count; n++)
                        {
                            strRowValue += dataGridView1.Rows[n].Cells[n].Value + ";";
                        }
                        strRowValue = strRowValue.TrimEnd(null);

                    }


                }

                // sw.Write(sw.NewLine);
            }

            sw.Flush();

            sw.Close();




            //MessageBox.Show("Mail Sent!", "Success", MessageBoxButtons.OK);
            AutoClosingMessageBox.Show("Sending mail\nPlease Wait..!", "OBS!", 7000);
        }

        public class AutoClosingMessageBox
        {
            System.Threading.Timer _timeoutTimer;
            string _caption;
            AutoClosingMessageBox(string text, string caption, int timeout)
            {
                _caption = caption;
                _timeoutTimer = new System.Threading.Timer(OnTimerElapsed,
                    null, timeout, System.Threading.Timeout.Infinite);
                MessageBox.Show(text, caption);
            }
            public static void Show(string text, string caption, int timeout)
            {
                new AutoClosingMessageBox(text, caption, timeout);
            }
            void OnTimerElapsed(object state)
            {
                IntPtr mbWnd = FindWindow(null, _caption);
                if (mbWnd != IntPtr.Zero)
                    SendMessage(mbWnd, WM_CLOSE, IntPtr.Zero, IntPtr.Zero);
                _timeoutTimer.Dispose();
            }
            const int WM_CLOSE = 0x0010;
            [System.Runtime.InteropServices.DllImport("user32.dll", SetLastError = true)]
            static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
            [System.Runtime.InteropServices.DllImport("user32.dll", CharSet = System.Runtime.InteropServices.CharSet.Auto)]
            static extern IntPtr SendMessage(IntPtr hWnd, UInt32 Msg, IntPtr wParam, IntPtr lParam);
        }

        private static List<string[]> ReadAndParseData(string path, char seperator)
        {
            var parsedData = new List<string[]>();
            using (var sr = new StreamReader(path))
            {
                string line;
                while ((line = sr.ReadLine()) != null)
                {
                    string[] row = line.Split(seperator);
                    parsedData.Add(row);
                }
            }
            return parsedData;
        }



        private void listViewSecurityGroups1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void moreButton_Click(object sender, EventArgs e)
        {

            Dictionary<string, string> temp = new Dictionary<string, string>();
            System.Diagnostics.Debug.WriteLine(dataGridView1.Rows.Count);
            foreach (DataGridViewRow row in dataGridView1.Rows)
            {
                if (row.Cells[0].Value != null)
                {
                    var name = row.Cells[0].Value.ToString();
                    var empl = row.Cells[4].Value.ToString();
                    temp.Add(name, empl);
                }

            }
            Form2 f2 = new Form2(temp);
            f2.ShowDialog();



        }

        private void generateUsersButton_Click(object sender, EventArgs e)
        {

            try
            {


                for (int m = 0; m < dataGridView1.Rows.Count - 1; m++)
                {

                    this.dataGridView1.Rows[m].Cells[0].Value = generateRandomUsers(3);

                }
                checkRandomGeneratedUsers();

            }

            catch (Exception x)
            {
                MessageBox.Show("ERROR: " + x.ToString());

            }
        }

        private string generateRandomUsers(int value)
        {
            // get 1st random string 
            string Rand1 = RandomString(value);

            // creat full rand string

            return Rand1;


        }
        private static Random random = new Random((int)DateTime.Now.Ticks);

        private string RandomString(int size)
        {
            StringBuilder builder = new StringBuilder();
            char ch;
            for (int i = 0; i < size; i++)
            {
                ch = Convert.ToChar(Convert.ToInt32(Math.Floor(26 * random.NextDouble() + 65)));
                builder.Append(ch);
            }

            return builder.ToString();
        }

        private void checkRandomGeneratedUsers()
        {



            try
            {
                for (int m = 0; m < dataGridView1.Rows.Count - 1; m++)
                {

                    var thisUsername = this.dataGridView1.Rows[m].Cells[0].Value.ToString();
                    //Findes lønnr i AD
                    DirectoryEntry enTry = new DirectoryEntry("LDAP://DC=contoso,DC=local");
                    DirectorySearcher mySearcher = new DirectorySearcher(enTry.Properties["sAMAccountName"].ToString()); // Find Brugernavn i Active Directory
                    mySearcher.Filter = "(&(objectClass=user)(sAMAccountName=" + mySearcher + "))";


                    //Findes username i AD
                    using (var domainContext = new PrincipalContext(ContextType.Domain, "contoso.local"))
                    {
                        mySearcher.Filter = "(&(objectClass=user)(sAMAccountName=" + thisUsername + "))";
                        using (var foundUser = UserPrincipal.FindByIdentity(domainContext, IdentityType.SamAccountName, thisUsername))
                        {
                            if (mySearcher.FindAll() != null)
                            {

                                // all users are avaliable
                                checkGeneratedUsersLabel.Text = "ALL OK!";
                            }

                            else
                            {

                                // Try again
                                for (int y = 0; y < dataGridView1.Rows.Count - 1; y++)
                                {

                                    dataGridView1.Rows[y].Cells[0].Value = generateRandomUsers(3).ToLower();

                                }
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Something went wrong!: " + ex.ToString());
            }
        }

    }
}
