﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.DirectoryServices;
using System.DirectoryServices.AccountManagement;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace $safeprojectname$
{
    public partial class Form2 : Form
    {
        DataModel.JetTimeEntities entities = new DataModel.JetTimeEntities();

        public Form2(Dictionary<string, string> dict)
        {
            InitializeComponent();
            try
            {
                foreach (var kvp in dict)
                {
                    //Does username exsists in database
                    if (entities.CrewmemberView.Any(u => u.CrewCode.Equals(kvp.Key)))
                    {
                        listBoxUsersExsists.Items.Add("database: " + kvp.Key);

                    }
                    else
                    {
                        listBoxUsersNotExsists1.Items.Add("username: " + kvp.Key); // Finder brugernavn og tilføjer til listen
                    }

                    //Findes username i AD
                    using (var domainContext = new PrincipalContext(ContextType.Domain, "contoso.local"))
                    {
                        using (var foundUser = UserPrincipal.FindByIdentity(domainContext, IdentityType.SamAccountName, kvp.Key))
                        {
                            if (foundUser != null)
                            {
                                listBoxUsersExsists.Items.Add("AD Username: " + kvp.Key);
                            }
                            else
                            {
                                listBoxUsersNotExsists1.Items.Add("AD Username: " + kvp.Key); // Finder brugernavn og tilføjer til listen
                            }
                        }
                    }

                    //findes lønnr i database
                    if (entities.CrewmemberView.Any(u => u.EmploymentNumber.Equals(kvp.Value)))
                    {
                        listBoxUsersExsists.Items.Add("database lønnr: " + kvp.Value);
                    }

                    //Findes lønnr i AD
                    DirectoryEntry enTry = new DirectoryEntry("LDAP://DC=contoso,DC=local");
                    DirectorySearcher mySearcher = new DirectorySearcher(enTry.Properties["pager"].ToString()); // Find lønnr i Active Directory


                    using (var domainContext = new PrincipalContext(ContextType.Domain, "contoso.local"))
                    {
                        mySearcher.Filter = "(&(objectClass=user)(pager=" + kvp.Value + "))";

                        if (mySearcher.FindAll().Count > 0)
                        {

                            listBoxUsersExsists.Items.Add("AD Lønnr: " + kvp.Value);
                        }
                        else
                        {
                            Console.WriteLine("Brugeren har INTET lønnr i Active Directory!");
                            listBoxUsersNotExsists1.Items.Add("AD Lønnr: " + kvp.Value); // Finder lønnr og tilføjer til listen
                        }
                    }
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Venligst indtast et Username & PayNo først :-)\n Luk vinduet ned og prøv igen.",
       "Fejl 40 fundet!",
       MessageBoxButtons.OK,
       MessageBoxIcon.Exclamation,
       MessageBoxDefaultButton.Button1);
                Console.WriteLine("Error! " + e.ToString());

            }
        }

        // Finding Member Of from user
        public string AuthenticateGroup(string userName)
        {


            try
            {
                DirectoryEntry entry = new DirectoryEntry("LDAP://DC=contoso,DC=local");
                DirectorySearcher mySearcher = new DirectorySearcher(entry);
                mySearcher.Filter = "(&(objectClass=user)(sAMAccountName=" + userName + "))";
                DirectoryEntry enTry = new DirectoryEntry("LDAP://DC=contoso,DC=local");



                UserPrincipal user = UserPrincipal.FindByIdentity(new PrincipalContext(ContextType.Domain, "contoso.local"), IdentityType.SamAccountName, userName);
                foreach (GroupPrincipal group in user.GetGroups())
                {
                    string tmp = group.ToString();
                    string[] values = tmp.Split(',');

                    foreach (string value in values)
                    {
                        if (value.Trim() == "")
                            continue;
                        listBoxUserMemberOf.Items.Add(value.Trim());
                    }

                }


            }
            catch (Exception xn)
            {
                MessageBox.Show("Venligst indtast et brugernavn først :-)\nPrøv igen.",
     "Fejl 40 fundet!",
     MessageBoxButtons.OK,
     MessageBoxIcon.Exclamation,
     MessageBoxDefaultButton.Button1);
                Console.WriteLine("Error! " + xn.ToString());
            }
            return null;
        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void Form2_Load(object sender, EventArgs e)
        {

        }

        private void findUserMemberOfbutton1_Click(object sender, EventArgs e)
        {
            copyMembersLabel2.Text = "";
            listBoxUserMemberOf.Items.Clear();

            if (userMemberOftextBox1.Text == "")
            {
                MessageBox.Show("Please enter a username :-)");


            }
            else
            {
                listBoxUserMemberOf.Items.Clear();
                AuthenticateGroup(userMemberOftextBox1.Text);
                string s1 = "";
                foreach (object item in listBoxUserMemberOf.Items) s1 += item.ToString() + "\r\n";
                Clipboard.SetText(s1);
                copyMembersLabel2.Text = "Copied All Members\nTo Clipboard!";
            }


        }

    }
}
